#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <cmath>

#include <iostream>
#include <Eigen/Dense>
#include <Eigen/Geometry>

using namespace std;
using namespace Eigen;

class vecfun_t {
public:
  virtual VectorXd eval(VectorXd &x)=0;
};

void GetJaco(vecfun_t &F,VectorXd &x,
             MatrixXd &J,double eps=1e-5) {
  VectorXd f = F.eval(x);
  int Ncol = x.size(), Nrow=f.size();
  J.resize(Nrow,Ncol);
  VectorXd x1,f1p,f1m;
  for (int j=0; j<Ncol; j++) {
    x1 = x;
    x1(j) += eps;
    f1p = F.eval(x1);
    x1(j) -= 2*eps;
    f1m = F.eval(x1);
    J.col(j) = (f1p-f1m)/(2*eps);
  }
}


int main() {
  return 0; 
}
